@Echo off

Set DMC_HOME=C:\opt\DigitalMars\8.52
Set DMCC=%DMC_HOME%\bin\dmc
Set FLAGS=-mn -w-
Set FLAGS_DEBUG=-C -g4hl -S
Set INC=-I%DMC_HOME%\include -I.
Set LIBS=snn.lib kernel32.lib user32.lib gdi32.lib advapi32.lib ws2_32.lib

if not exist shared mkdir shared
if not exist shared Goto :fail
if not exist static mkdir static
if not exist static Goto :fail



rem * * * * *
rem Build the DLL:
rem * * * * *
%DMCC% -c %FLAGS% -DBUILD_DLL %INC% DLL.c -oshared\DLL.obj
if not exist shared\DLL.obj Goto :fail

%DMCC% -c %FLAGS% %FLAGS_DEBUG% -DBUILD_DLL %INC% Greet.c -oshared\Greet.obj
if not exist shared\Greet.obj Goto :fail

rem How can the link statement be silenced?
%DMCC% -WD %FLAGS% %FLAGS_DEBUG% shared\DLL.obj shared\Greet.obj -oMy.dll %LIBS%
if not exist My.dll Goto :fail

%DMC_HOME%\bin\implib /noignorecase /system MyImport.lib My.dll >nul
if not exist MyImport.lib Goto :fail



rem * * * * *
rem Build the static library:
rem * * * * *
%DMCC% -c %FLAGS% -DBUILD_LIBRARY %INC% Greet.c -ostatic\Greet.obj
%DMC_HOME%\bin\lib -c -n My.lib static\Greet.obj
if not exist My.lib Goto :fail



rem * * * * *
rem Build the C DLL test:
rem * * * * *
%DMCC% %FLAGS% %FLAGS_DEBUG% %INC% Ctest.c -oCshared.exe MyImport.lib
if not exist Cshared.exe Goto :fail



rem * * * * *
rem Build the C static library test:
rem * * * * *
%DMCC% %FLAGS% -DUSE_LIBRARY %INC% Ctest.c -oCstatic.exe My.lib %LIBS%
if not exist Cstatic.exe Goto :fail



rem * * * * *
rem Run the tests:
rem * * * * *
@Echo Run the C static library test:
Cstatic
@Echo Run the C DLL test:
rem Cshared
%DMC_HOME%\bin\WinDbg Cshared



Goto :clean



:fail
@Echo:
@Echo Build failed!
@Echo:



:clean
if not exist shared Goto :static
if exist shared\*.obj del /Q shared\*
rmdir shared

:static
if not exist static Goto :other
if exist static\*.obj del /Q static\*
rmdir static

:other
if exist Cshared.exe del Cshared.exe
if exist Cshared.map del Cshared.map
if exist Cshared.txt del Cshared.txt
if exist Cstatic.exe del Cstatic.exe
if exist Cstatic.map del Cstatic.map
if exist Cstatic.txt del Cstatic.txt
if exist Ctest.obj del Ctest.obj
if exist My.def del My.def
if exist My.dll del My.dll
if exist My.lib del My.lib
if exist My.map del My.map
if exist MyImport.lib del MyImport.lib

